1
$\begingroup$

Given an array of integers I have to return true if all the elements in the array are different or all the elements are the same. Otherwise, I have to return false.

E.g.

[1, 1, 1, 1] - all the elements are the same, so it is true

[12, 20, 1, 23] - all the elements are different, so it is also true

[12, 20, 1, 1] - we have just two 1, so it is false

The easy thing I was able to come up with is to use a hashmap to map an integer to a number of occurrences of that integer in the array. And then to iterate over the hashmap and check if there is at least one entry whose value is greater than 1 and is not equal to the length of the array, then I return false. Otherwise, I return true after the iteration.

The problem with my solution is that it has a linear space complexity and I feel that it should be possible to somehow solve the problem using a constant space complexity and linear time complexity.

So, could someone help me come up with an O(1) space complexity and O(n) linear complexity with respect to the array size solution, please?

I am working on this problem just for fun.

$\endgroup$
1

2 Answers 2

3
$\begingroup$

The problem does not have any $O(n)$ time algorithm. Note that it is easy to check in linear time if all the elements in the array are the same or not. However, to check if all the elements are district, the problem is known as Element distinctness problem. And, this problem has an $\Omega(n \log n)$ lower bound complexity (for comparison based models). More technically, your problem can be reduced to element distinctness problem in linear time.

Therefore, the best possible solution here is $O(n \log n)$ time algorithm. For that, you can employ merge sort algorithm using a linked list. It also has an $O(1)$ space complexity.


Note: Since the input is a set of integers, you can employ Radix sort to solve the problem in linear time.

$\endgroup$
12
  • 1
    $\begingroup$ This isn't quite right as stated. The $\Omega(n \log n)$ time lower bound only applies in the algebraic decision tree model, but other algorithms might well be faster. For instance, it is known how to sort integers faster than $\Theta(n \log n)$, by going beyond the comparison-based model, and you can use that for element distinctness. The poster gives a randomized linear-time algorithm and they seem happy with randomized linear-time algorithms; their question seems to be primarily about space complexity. $\endgroup$
    – D.W.
    May 12, 2021 at 21:55
  • $\begingroup$ @D.W. The hash map's worst-case complexity is $O(n)$. So the posted answer is not actually linear time. $\endgroup$ May 12, 2021 at 22:01
  • $\begingroup$ @D.W. And I agree that the lower bound of $\Theta(n \log n)$ is for comparison-based model. This is generally the assumption in such cases. $\endgroup$ May 12, 2021 at 22:02
  • $\begingroup$ @D.W. If we use a hash map with $O(t)$ space, where $t$ is the value of the maximum integer. In that case, hash map gives $O(n)$ time complexity. $\endgroup$ May 12, 2021 at 22:04
  • $\begingroup$ @D.W. But that was not stated in the algorithm. :/ $\endgroup$ May 12, 2021 at 22:07
0
$\begingroup$

I have just started to look into time and space complexity and it is all a mess for me atm, but this particular problem can be solved with converting the list of integers into a set, then comparing lenghts. Would that be linear in time? Sample function:

def same_diff(a_list):
    a_list.sort()
    temp_set = set(a_list)
    if len(temp_set) <= 1 or len(temp_set) == len(a_list):
        return True
    return False

Sorting is not required, but neater I guess?

Thanks :)

$\endgroup$
3
  • $\begingroup$ What do you think is the running time to convert to a set? How do you imagine that is done? Python has to implement it in some way. It is not free. $\endgroup$
    – D.W.
    Jan 30 at 18:58
  • $\begingroup$ not required, but neater Sir William would oppose. $\endgroup$
    – greybeard
    Jan 31 at 15:29
  • $\begingroup$ well all the mentions I find of converting a list to a set talks in O(N) time complexity - iterating over the list is O(N) and and adding each element to a hash set is O(1) - but as I said I'm really at the start of my studies regarding time/space complexity, so really here to learn from you :) $\endgroup$
    – Zsolt Pal
    Jan 31 at 19:38

Your Answer

By clicking “Post Your Answer”, you agree to our terms of service and acknowledge that you have read and understand our privacy policy and code of conduct.

Not the answer you're looking for? Browse other questions tagged or ask your own question.